/[gentoo-x86]/eclass/qt4-build.eclass
Gentoo

Diff of /eclass/qt4-build.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.74 Revision 1.139
1# Copyright 1999-2009 Gentoo Foundation 1# Copyright 1999-2012 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/qt4-build.eclass,v 1.74 2010/05/30 10:31:05 spatz Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/qt4-build.eclass,v 1.139 2012/11/12 09:28:53 pesa Exp $
4 4
5# @ECLASS: qt4-build.eclass 5# @ECLASS: qt4-build.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# Ben de Groot <yngwin@gentoo.org>, 7# Qt herd <qt@gentoo.org>
8# Markos Chandras <hwoarang@gentoo.org>,
9# Caleb Tennis <caleb@gentoo.org>
10# Alex Alexander <wired@gentoo.org>
11# @BLURB: Eclass for Qt4 split ebuilds. 8# @BLURB: Eclass for Qt4 split ebuilds.
12# @DESCRIPTION: 9# @DESCRIPTION:
13# This eclass contains various functions that are used when building Qt4 10# This eclass contains various functions that are used when building Qt4.
14 11
12case ${EAPI} in
13 3|4|5) : ;;
14 *) die "qt4-build.eclass: unsupported EAPI=${EAPI:-0}" ;;
15esac
16
15inherit base eutils multilib toolchain-funcs flag-o-matic versionator 17inherit eutils flag-o-matic multilib toolchain-funcs versionator
18
19if [[ ${PV} == *9999* ]]; then
20 QT4_BUILD_TYPE="live"
21 inherit git-2
22else
23 QT4_BUILD_TYPE="release"
24fi
25
26HOMEPAGE="http://qt-project.org/ http://qt.digia.com/"
27LICENSE="|| ( LGPL-2.1 GPL-3 )"
16 28
17MY_PV=${PV/_/-} 29MY_PV=${PV/_/-}
18if version_is_at_least 4.5.99999999; then
19 MY_P=qt-everywhere-opensource-src-${MY_PV} 30MY_P=qt-everywhere-opensource-src-${MY_PV}
31
32case ${QT4_BUILD_TYPE} in
33 live)
34 EGIT_REPO_URI="git://gitorious.org/qt/qt.git
35 https://git.gitorious.org/qt/qt.git"
36 EGIT_BRANCH=${PV%.9999}
37 ;;
38 release)
39 if version_is_at_least 4.8.1; then
40 SRC_URI="http://releases.qt-project.org/qt4/source/${MY_P}.tar.gz"
41 else
42 SRC_URI="http://get.qt.nokia.com/qt/source/${MY_P}.tar.gz"
43 fi
44 ;;
45esac
46
47IUSE="aqua debug pch"
20 [[ ${CATEGORY}/${PN} != x11-libs/qt-xmlpatterns ]] && IUSE="+exceptions" 48[[ ${CATEGORY}/${PN} != x11-libs/qt-xmlpatterns ]] && IUSE+=" +exceptions"
21else 49if version_is_at_least 4.8; then
22 MY_P=qt-x11-opensource-src-${MY_PV} 50 [[ ${CATEGORY}/${PN} != x11-libs/qt-webkit ]] && IUSE+=" c++0x"
51 version_is_at_least 4.8.3 || IUSE+=" qpa"
23fi 52fi
24 53
25HOMEPAGE="http://qt.nokia.com/" 54DEPEND="virtual/pkgconfig"
26SRC_URI="http://get.qt.nokia.com/qt/source/${MY_P}.tar.gz" 55if [[ ${QT4_BUILD_TYPE} == live ]]; then
27 56 DEPEND+=" dev-lang/perl"
28LICENSE="|| ( LGPL-2.1 GPL-3 )" 57fi
29IUSE+=" debug pch aqua"
30 58
31RDEPEND=" 59RDEPEND="
32 !<x11-libs/qt-assistant-${PV} 60 !<x11-libs/qt-assistant-${PV}:4
33 !>x11-libs/qt-assistant-${PV}-r9999 61 !>x11-libs/qt-assistant-${PV}-r9999:4
62 !<x11-libs/qt-bearer-${PV}:4
63 !>x11-libs/qt-bearer-${PV}-r9999:4
34 !<x11-libs/qt-core-${PV} 64 !<x11-libs/qt-core-${PV}:4
35 !>x11-libs/qt-core-${PV}-r9999 65 !>x11-libs/qt-core-${PV}-r9999:4
36 !<x11-libs/qt-dbus-${PV} 66 !<x11-libs/qt-dbus-${PV}:4
37 !>x11-libs/qt-dbus-${PV}-r9999 67 !>x11-libs/qt-dbus-${PV}-r9999:4
68 !<x11-libs/qt-declarative-${PV}:4
69 !>x11-libs/qt-declarative-${PV}-r9999:4
38 !<x11-libs/qt-demo-${PV} 70 !<x11-libs/qt-demo-${PV}:4
39 !>x11-libs/qt-demo-${PV}-r9999 71 !>x11-libs/qt-demo-${PV}-r9999:4
40 !<x11-libs/qt-gui-${PV} 72 !<x11-libs/qt-gui-${PV}:4
41 !>x11-libs/qt-gui-${PV}-r9999 73 !>x11-libs/qt-gui-${PV}-r9999:4
42 !<x11-libs/qt-multimedia-${PV} 74 !<x11-libs/qt-multimedia-${PV}:4
43 !>x11-libs/qt-multimedia-${PV}-r9999 75 !>x11-libs/qt-multimedia-${PV}-r9999:4
44 !<x11-libs/qt-opengl-${PV} 76 !<x11-libs/qt-opengl-${PV}:4
45 !>x11-libs/qt-opengl-${PV}-r9999 77 !>x11-libs/qt-opengl-${PV}-r9999:4
78 !<x11-libs/qt-openvg-${PV}:4
79 !>x11-libs/qt-openvg-${PV}-r9999:4
46 !<x11-libs/qt-phonon-${PV} 80 !<x11-libs/qt-phonon-${PV}:4
47 !>x11-libs/qt-phonon-${PV}-r9999 81 !>x11-libs/qt-phonon-${PV}-r9999:4
48 !<x11-libs/qt-qt3support-${PV} 82 !<x11-libs/qt-qt3support-${PV}:4
49 !>x11-libs/qt-qt3support-${PV}-r9999 83 !>x11-libs/qt-qt3support-${PV}-r9999:4
50 !<x11-libs/qt-script-${PV} 84 !<x11-libs/qt-script-${PV}:4
51 !>x11-libs/qt-script-${PV}-r9999 85 !>x11-libs/qt-script-${PV}-r9999:4
52 !<x11-libs/qt-sql-${PV} 86 !<x11-libs/qt-sql-${PV}:4
53 !>x11-libs/qt-sql-${PV}-r9999 87 !>x11-libs/qt-sql-${PV}-r9999:4
54 !<x11-libs/qt-svg-${PV} 88 !<x11-libs/qt-svg-${PV}:4
55 !>x11-libs/qt-svg-${PV}-r9999 89 !>x11-libs/qt-svg-${PV}-r9999:4
56 !<x11-libs/qt-test-${PV} 90 !<x11-libs/qt-test-${PV}:4
57 !>x11-libs/qt-test-${PV}-r9999 91 !>x11-libs/qt-test-${PV}-r9999:4
58 !<x11-libs/qt-webkit-${PV} 92 !<x11-libs/qt-webkit-${PV}:4
59 !>x11-libs/qt-webkit-${PV}-r9999 93 !>x11-libs/qt-webkit-${PV}-r9999:4
60 !<x11-libs/qt-xmlpatterns-${PV} 94 !<x11-libs/qt-xmlpatterns-${PV}:4
61 !>x11-libs/qt-xmlpatterns-${PV}-r9999 95 !>x11-libs/qt-xmlpatterns-${PV}-r9999:4
62" 96"
63 97
64S=${WORKDIR}/${MY_P} 98S=${WORKDIR}/${MY_P}
65 99
66# @FUNCTION: qt4-build_pkg_setup 100# @FUNCTION: qt4-build_pkg_setup
67# @DESCRIPTION: 101# @DESCRIPTION:
68# Sets up S, MY_P, PATH, and LD_LIBRARY_PATH 102# Sets up PATH and LD_LIBRARY_PATH.
69qt4-build_pkg_setup() { 103qt4-build_pkg_setup() {
70 [[ ${EAPI} == 2 ]] && use !prefix && EPREFIX=
71
72 # Protect users by not allowing downgrades between releases 104 # Protect users by not allowing downgrades between releases.
73 # Downgrading revisions within the same release should be allowed 105 # Downgrading revisions within the same release should be allowed.
74 if has_version '>'${CATEGORY}/${P}-r9999 ; then 106 if has_version ">${CATEGORY}/${P}-r9999:4"; then
75 if [[ -z $I_KNOW_WHAT_I_AM_DOING ]] ; then 107 if [[ -z ${I_KNOW_WHAT_I_AM_DOING} ]]; then
76 eerror "Sanity check to keep you from breaking your system:" 108 eerror " *** Sanity check to keep you from breaking your system ***"
77 eerror " Downgrading Qt is completely unsupported and will break your system!" 109 eerror "Downgrading Qt is completely unsupported and will break your system!"
78 die "aborting to save your system" 110 die "aborting to save your system"
79 else 111 else
80 ewarn "Downgrading Qt is completely unsupported and will break your system!" 112 ewarn "Downgrading Qt is completely unsupported and will break your system!"
81 fi 113 fi
82 fi
83
84 if [[ "${PN}" == "qt-webkit" ]]; then
85 eshopts_push -s extglob
86 if is-flagq '-g?(gdb)?([0-9])'; then
87 echo
88 ewarn "You have enabled debug info (probably have -g or -ggdb in your \$C{,XX}FLAGS)."
89 ewarn "You may experience really long compilation times and/or increased memory usage."
90 ewarn "If compilation fails, please try removing -g{,gdb} before reporting a bug."
91 ewarn "For more info check out bug #307861"
92 echo
93 fi
94 eshopts_pop
95 fi 114 fi
96 115
97 PATH="${S}/bin${PATH:+:}${PATH}" 116 PATH="${S}/bin${PATH:+:}${PATH}"
98 if [[ ${CHOST} != *-darwin* ]]; then 117 if [[ ${CHOST} != *-darwin* ]]; then
99 LD_LIBRARY_PATH="${S}/lib${LD_LIBRARY_PATH:+:}${LD_LIBRARY_PATH}" 118 LD_LIBRARY_PATH="${S}/lib${LD_LIBRARY_PATH:+:}${LD_LIBRARY_PATH}"
104 # avoid extract failure. 123 # avoid extract failure.
105 [[ ${CHOST} == *-apple-darwin* ]] && \ 124 [[ ${CHOST} == *-apple-darwin* ]] && \
106 QT4_EXTRACT_DIRECTORIES="src/gui/kernel/qapplication_mac.mm 125 QT4_EXTRACT_DIRECTORIES="src/gui/kernel/qapplication_mac.mm
107 ${QT4_EXTRACT_DIRECTORIES}" 126 ${QT4_EXTRACT_DIRECTORIES}"
108 fi 127 fi
109
110 # Make sure ebuilds use the required EAPI
111 if [[ ${EAPI} != [23] ]]; then
112 eerror "The qt4-build eclass requires EAPI=2 or EAPI=3, but this ebuild is using"
113 eerror "EAPI=${EAPI:-0}. The ebuild author or editor failed. This ebuild needs to be"
114 eerror "fixed. Using qt4-build eclass without EAPI=2 or EAPI=3 will fail."
115 die "qt4-build eclass requires EAPI=2 or EAPI=3"
116 fi
117
118 if ! version_is_at_least 4.1 $(gcc-version); then
119 ewarn "Using a GCC version lower than 4.1 is not supported!"
120 fi
121} 128}
129
130# @ECLASS-VARIABLE: QT4_EXTRACT_DIRECTORIES
131# @DEFAULT_UNSET
132# @DESCRIPTION:
133# Space-separated list including the directories that will be extracted from
134# Qt tarball.
122 135
123# @ECLASS-VARIABLE: QT4_TARGET_DIRECTORIES 136# @ECLASS-VARIABLE: QT4_TARGET_DIRECTORIES
137# @DEFAULT_UNSET
124# @DESCRIPTION: 138# @DESCRIPTION:
125# Arguments for build_target_directories. Takes the directories, in which the 139# Arguments for build_target_directories. Takes the directories in which the
126# code should be compiled. This is a space-separated list 140# code should be compiled. This is a space-separated list.
127
128# @ECLASS-VARIABLE: QT4_EXTRACT_DIRECTORIES
129# @DESCRIPTION:
130# Space separated list including the directories that will be extracted from Qt
131# tarball
132 141
133# @FUNCTION: qt4-build_src_unpack 142# @FUNCTION: qt4-build_src_unpack
134# @DESCRIPTION: 143# @DESCRIPTION:
135# Unpacks the sources 144# Unpacks the sources.
136qt4-build_src_unpack() { 145qt4-build_src_unpack() {
137 setqtenv 146 setqtenv
138 local target targets= 147
148 if ! version_is_at_least 4.1 $(gcc-version); then
149 ewarn "Using a GCC version lower than 4.1 is not supported."
150 fi
151
152 if [[ ${PN} == qt-webkit ]]; then
153 eshopts_push -s extglob
154 if is-flagq '-g?(gdb)?([1-9])'; then
155 echo
156 ewarn "You have enabled debug info (probably have -g or -ggdb in your CFLAGS/CXXFLAGS)."
157 ewarn "You may experience really long compilation times and/or increased memory usage."
158 ewarn "If compilation fails, please try removing -g/-ggdb before reporting a bug."
159 ewarn "For more info check out https://bugs.gentoo.org/307861"
160 echo
161 fi
162 eshopts_pop
163 fi
164
165 case ${QT4_BUILD_TYPE} in
166 live)
167 git-2_src_unpack
168 ;;
169 release)
170 local tarball="${MY_P}.tar.gz" target= targets=
139 for target in configure LICENSE.GPL3 LICENSE.LGPL projects.pro \ 171 for target in configure LICENSE.GPL3 LICENSE.LGPL projects.pro \
140 src/{qbase,qt_targets,qt_install}.pri bin config.tests mkspecs qmake \ 172 src/{qbase,qt_targets,qt_install}.pri bin config.tests \
141 ${QT4_EXTRACT_DIRECTORIES}; do 173 mkspecs qmake ${QT4_EXTRACT_DIRECTORIES}
174 do
142 targets+=" ${MY_P}/${target}" 175 targets+="${MY_P}/${target} "
143 done 176 done
144 177
178 ebegin "Unpacking parts of ${tarball}:" ${targets//${MY_P}\/}
145 echo tar xzf "${DISTDIR}"/${MY_P}.tar.gz ${targets} 179 tar -xzf "${DISTDIR}/${tarball}" ${targets}
146 tar xzf "${DISTDIR}"/${MY_P}.tar.gz ${targets} || die 180 eend $? || die "failed to unpack"
181 ;;
182 esac
147} 183}
148 184
149# @ECLASS-VARIABLE: PATCHES 185# @ECLASS-VARIABLE: PATCHES
186# @DEFAULT_UNSET
150# @DESCRIPTION: 187# @DESCRIPTION:
151# In case you have patches to apply, specify them in PATCHES variable. Make sure 188# PATCHES array variable containing all various patches to be applied.
152# to specify the full path. This variable is necessary for src_prepare phase. 189# This variable is expected to be defined in global scope of ebuild.
153# example: 190# Make sure to specify the full path. This variable is utilised in
154# PATCHES="${FILESDIR}"/mypatch.patch 191# src_prepare() phase.
155# ${FILESDIR}"/mypatch2.patch"
156# 192#
193# @CODE
194# PATCHES=( "${FILESDIR}/mypatch.patch"
195# "${FILESDIR}/patches_folder/" )
196# @CODE
157 197
158# @FUNCTION: qt4-build_src_prepare 198# @FUNCTION: qt4-build_src_prepare
159# @DESCRIPTION: 199# @DESCRIPTION:
160# Prepare the sources before the configure phase. Strip CFLAGS if necessary, and fix 200# Prepare the sources before the configure phase. Strip CFLAGS if necessary, and fix
161# source files in order to respect CFLAGS/CXXFLAGS/LDFLAGS specified on /etc/make.conf. 201# the build system in order to respect CFLAGS/CXXFLAGS/LDFLAGS specified in /etc/make.conf.
162qt4-build_src_prepare() { 202qt4-build_src_prepare() {
163 setqtenv 203 setqtenv
164 cd "${S}"
165 204
166 # fix qt 4.7 regression that skips -fvisibility=hidden 205 if [[ ${QT4_BUILD_TYPE} == live ]]; then
167 if version_is_at_least "4.7.0_beta1"; then 206 QTDIR="." ./bin/syncqt || die "syncqt failed"
168 sed -e "s/^gcc|g++)/*gcc|*g++)/" \
169 -i config.tests/unix/fvisibility.test ||
170 die "visibility fixing sed failed"
171 fi 207 fi
208
209 # avoid X11 dependency in non-gui packages
210 local nolibx11_pkgs="qt-core qt-dbus qt-script qt-sql qt-test qt-xmlpatterns"
211 has ${PN} ${nolibx11_pkgs} && qt_nolibx11
172 212
173 if use aqua; then 213 if use aqua; then
174 # provide a proper macx-g++-64 214 # provide a proper macx-g++-64
175 use x64-macos && ln -s macx-g++ mkspecs/$(qt_mkspecs_dir) 215 use x64-macos && ln -s macx-g++ mkspecs/$(qt_mkspecs_dir)
176 216
177 sed -e '/^CONFIG/s:app_bundle::' \ 217 sed -e '/^CONFIG/s:app_bundle::' \
178 -e '/^CONFIG/s:plugin_no_soname:plugin_with_soname absolute_library_soname:' \ 218 -e '/^CONFIG/s:plugin_no_soname:plugin_with_soname absolute_library_soname:' \
179 -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die "sed failed" 219 -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
180 fi 220 fi
181 221
182 if [[ ${PN} != qt-core ]]; then 222 if [[ ${PN} != qt-core ]]; then
183 skip_qmake_build_patch 223 skip_qmake_build
184 skip_project_generation_patch 224 skip_project_generation
185 symlink_binaries_to_buildtree 225 symlink_binaries_to_buildtree
186 fi 226 fi
187 227
188 if [[ ${CHOST} == *86*-apple-darwin* ]] ; then 228 if [[ ${CHOST} == *86*-apple-darwin* ]]; then
189 # qmake bus errors with -O2 but -O3 works 229 # qmake bus errors with -O2 or -O3 but -O1 works
230 # Bug 373061
190 replace-flags -O2 -O3 231 replace-flags -O[23] -O1
191 fi 232 fi
192 233
193 # Bug 178652 234 # Bug 178652
194 if [[ $(gcc-major-version) == 3 ]] && use amd64; then 235 if [[ $(gcc-major-version) == 3 ]] && use amd64; then
195 ewarn "Appending -fno-gcse to CFLAGS/CXXFLAGS" 236 ewarn "Appending -fno-gcse to CFLAGS/CXXFLAGS"
196 append-flags -fno-gcse 237 append-flags -fno-gcse
197 fi 238 fi
198 239
240 if use_if_iuse c++0x; then
241 append-cxxflags -std=c++0x
242 fi
243
199 # Unsupported old gcc versions - hardened needs this :( 244 # Unsupported old gcc versions - hardened needs this :(
200 if [[ $(gcc-major-version) -lt 4 ]] ; then 245 if [[ $(gcc-major-version) -lt 4 ]]; then
201 ewarn "Appending -fno-stack-protector to CXXFLAGS" 246 ewarn "Appending -fno-stack-protector to CXXFLAGS"
202 append-cxxflags -fno-stack-protector 247 append-cxxflags -fno-stack-protector
203 # Bug 253127 248 # Bug 253127
204 sed -e "/^QMAKE_CFLAGS\t/ s:$: -fno-stack-protector-all:" \ 249 sed -e "/^QMAKE_CFLAGS\t/ s:$: -fno-stack-protector-all:" \
205 -i "${S}"/mkspecs/common/g++.conf || die "sed ${S}/mkspecs/common/g++.conf failed" 250 -i mkspecs/common/g++.conf || die
206 fi 251 fi
207 252
208 # Bug 261632 253 # Bug 261632
209 if use ppc64; then 254 if use ppc64; then
210 ewarn "Appending -mminimal-toc to CFLAGS/CXXFLAGS" 255 ewarn "Appending -mminimal-toc to CFLAGS/CXXFLAGS"
211 append-flags -mminimal-toc 256 append-flags -mminimal-toc
212 fi 257 fi
213 258
214 # Bug 282984 && Bug 295530 259 # Respect CC, CXX, {C,CXX,LD}FLAGS in .qmake.cache
215 sed -e "s:\(^SYSTEM_VARIABLES\):CC=$(tc-getCC)\nCXX=$(tc-getCXX)\nCFLAGS=\"${CFLAGS}\"\nCXXFLAGS=\"${CXXFLAGS}\"\nLDFLAGS=\"${LDFLAGS}\"\n\1:" \ 260 sed -e "/^SYSTEM_VARIABLES=/i \
216 -i configure || die "sed qmake compilers failed" 261 CC='$(tc-getCC)'\n\
217 # bug 321335 262 CXX='$(tc-getCXX)'\n\
263 CFLAGS='${CFLAGS}'\n\
264 CXXFLAGS='${CXXFLAGS}'\n\
265 LDFLAGS='${LDFLAGS}'\n\
266 QMakeVar set QMAKE_CFLAGS_RELEASE\n\
267 QMakeVar set QMAKE_CFLAGS_DEBUG\n\
268 QMakeVar set QMAKE_CXXFLAGS_RELEASE\n\
269 QMakeVar set QMAKE_CXXFLAGS_DEBUG\n\
270 QMakeVar set QMAKE_LFLAGS_RELEASE\n\
271 QMakeVar set QMAKE_LFLAGS_DEBUG\n"\
272 -i configure \
273 || die "sed SYSTEM_VARIABLES failed"
274
275 # Respect CC, CXX, LINK and *FLAGS in config.tests
276 find config.tests/unix -name '*.test' -type f -print0 | xargs -0 \
277 sed -i -e "/bin\/qmake/ s: \"QT_BUILD_TREE=: \
278 'QMAKE_CC=$(tc-getCC)' 'QMAKE_CXX=$(tc-getCXX)' 'QMAKE_LINK=$(tc-getCXX)' \
279 'QMAKE_CFLAGS+=${CFLAGS}' 'QMAKE_CXXFLAGS+=${CXXFLAGS}' 'QMAKE_LFLAGS+=${LDFLAGS}'&:" \
280 || die "sed config.tests failed"
281
218 if version_is_at_least 4.6; then 282 if ! version_is_at_least 4.8; then
219 find ./config.tests/unix -name "*.test" -type f -exec grep -lZ \$MAKE '{}' \; | \ 283 # Strip predefined CFLAGS from mkspecs (bugs 312689 and 352778)
220 xargs -0 \ 284 sed -i -e '/^QMAKE_CFLAGS_RELEASE/s:+=.*:+=:' mkspecs/common/g++.conf || die
221 sed -e "s:\(\$MAKE\):\1 CC=$(tc-getCC) CXX=$(tc-getCXX) LD=$(tc-getCXX) LINK=$(tc-getCXX):g" \
222 -i || die "sed test compilers failed"
223 fi 285 fi
224 286
225 # Bug 172219 287 # Bug 172219
226 sed -e "s:X11R6/::" \ 288 sed -e 's:/X11R6/:/:' -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
227 -i "${S}"/mkspecs/$(qt_mkspecs_dir)/qmake.conf || die "sed ${S}/mkspecs/$(qt_mkspecs_dir)/qmake.conf failed"
228 289
229 if [[ ${CHOST} == *-darwin* ]]; then 290 if [[ ${CHOST} == *-darwin* ]]; then
230 # Set FLAGS *and* remove -arch, since our gcc-apple is multilib 291 # Set FLAGS *and* remove -arch, since our gcc-apple is multilib
231 # crippled (by design) :/ 292 # crippled (by design) :/
293 local mac_gpp_conf=
294 if [[ -f mkspecs/common/mac-g++.conf ]]; then
295 # qt < 4.8 has mac-g++.conf
296 mac_gpp_conf="mkspecs/common/mac-g++.conf"
297 elif [[ -f mkspecs/common/g++-macx.conf ]]; then
298 # qt >= 4.8 has g++-macx.conf
299 mac_gpp_conf="mkspecs/common/g++-macx.conf"
300 else
301 die "no known conf file for mac found"
302 fi
303 sed \
232 sed -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \ 304 -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \
233 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \ 305 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \
234 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=-headerpad_max_install_names ${LDFLAGS}:" \ 306 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=-headerpad_max_install_names ${LDFLAGS}:" \
235 -e "s:-arch\s\w*::g" \ 307 -e "s:-arch\s\w*::g" \
236 -i mkspecs/common/mac-g++.conf || die "sed mkspecs/common/mac-g++.conf failed" 308 -i ${mac_gpp_conf} \
309 || die "sed ${mac_gpp_conf} failed"
237 310
238 # Fix configure's -arch settings that appear in qmake/Makefile and also 311 # Fix configure's -arch settings that appear in qmake/Makefile and also
239 # fix arch handling (automagically duplicates our -arch arg and breaks 312 # fix arch handling (automagically duplicates our -arch arg and breaks
240 # pch). Additionally disable Xarch support. 313 # pch). Additionally disable Xarch support.
314 local mac_gcc_confs="${mac_gpp_conf}"
315 if [[ -f mkspecs/common/gcc-base-macx.conf ]]; then
316 mac_gcc_confs+=" mkspecs/common/gcc-base-macx.conf"
317 fi
241 sed \ 318 sed \
242 -e "s:-arch i386::" \ 319 -e "s:-arch i386::" \
243 -e "s:-arch ppc::" \ 320 -e "s:-arch ppc::" \
244 -e "s:-arch x86_64::" \ 321 -e "s:-arch x86_64::" \
245 -e "s:-arch ppc64::" \ 322 -e "s:-arch ppc64::" \
246 -e "s:-arch \$i::" \ 323 -e "s:-arch \$i::" \
247 -e "/if \[ ! -z \"\$NATIVE_64_ARCH\" \]; then/,/fi/ d" \ 324 -e "/if \[ ! -z \"\$NATIVE_64_ARCH\" \]; then/,/fi/ d" \
248 -e "s:CFG_MAC_XARCH=yes:CFG_MAC_XARCH=no:g" \ 325 -e "s:CFG_MAC_XARCH=yes:CFG_MAC_XARCH=no:g" \
249 -e "s:-Xarch_x86_64::g" \ 326 -e "s:-Xarch_x86_64::g" \
250 -e "s:-Xarch_ppc64::g" \ 327 -e "s:-Xarch_ppc64::g" \
251 -i configure mkspecs/common/mac-g++.conf || die "sed configure failed" 328 -i configure ${mac_gcc_confs} \
329 || die "sed -arch/-Xarch failed"
252 330
253 # On Snow Leopard don't fall back to 10.5 deployment target. 331 # On Snow Leopard don't fall back to 10.5 deployment target.
254 if [[ ${CHOST} == *-apple-darwin10 ]] ; then 332 if [[ ${CHOST} == *-apple-darwin10 ]]; then
255 sed -e "s:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET.*:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET 10.6:g" \ 333 sed -e "s:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET.*:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET 10.6:g" \
256 -e "s:-mmacosx-version-min=10.[0-9]:-mmacosx-version-min=10.6:g" \ 334 -e "s:-mmacosx-version-min=10.[0-9]:-mmacosx-version-min=10.6:g" \
257 -i configure mkspecs/common/mac-g++.conf || die "sed configure failed" 335 -i configure ${mac_gpp_conf} \
336 || die "sed deployment target failed"
258 fi 337 fi
259 fi 338 fi
260 339
261 # this one is needed for all systems with a separate -liconv, apart from 340 # this one is needed for all systems with a separate -liconv, apart from
262 # Darwin, for which the sources already cater for -liconv 341 # Darwin, for which the sources already cater for -liconv
263 if use !elibc_glibc && [[ ${CHOST} != *-darwin* ]] ; then 342 if use !elibc_glibc && [[ ${CHOST} != *-darwin* ]]; then
264 sed \ 343 sed -e 's|mac:\(LIBS += -liconv\)|\1|g' \
265 -e "s|mac:LIBS += -liconv|LIBS += -liconv|g" \
266 -i config.tests/unix/iconv/iconv.pro \ 344 -i config.tests/unix/iconv/iconv.pro \
267 || die "sed on iconv.pro failed" 345 || die "sed iconv.pro failed"
268 fi 346 fi
269 347
270 # we need some patches for Solaris 348 # we need some patches for Solaris
271 sed -i \
272 -e '/^QMAKE_LFLAGS_THREAD/a\QMAKE_LFLAGS_DYNAMIC_LIST = -Wl,--dynamic-list,' \ 349 sed -i -e '/^QMAKE_LFLAGS_THREAD/a\QMAKE_LFLAGS_DYNAMIC_LIST = -Wl,--dynamic-list,' \
273 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die 350 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
274 # use GCC over SunStudio 351 # use GCC over SunStudio
275 sed -i -e '/PLATFORM=solaris-cc/s/cc/g++/' configure || die 352 sed -i -e '/PLATFORM=solaris-cc/s/cc/g++/' configure || die
276 # don't flirt with non-Prefix stuff, we're quite possessive 353 # do not flirt with non-Prefix stuff, we're quite possessive
277 sed -i -e '/^QMAKE_\(LIB\|INC\)DIR\(_X11\|_OPENGL\|\)\t/s/=.*$/=/' \ 354 sed -i -e '/^QMAKE_\(LIB\|INC\)DIR\(_X11\|_OPENGL\|\)\t/s/=.*$/=/' \
278 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die 355 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
279 356
280 base_src_prepare 357 # apply patches
358 [[ -n ${PATCHES[@]} ]] && epatch "${PATCHES[@]}"
359 epatch_user
281} 360}
282 361
283# @FUNCTION: qt4-build_src_configure 362# @FUNCTION: qt4-build_src_configure
284# @DESCRIPTION: 363# @DESCRIPTION:
285# Default configure phase 364# Default configure phase
286qt4-build_src_configure() { 365qt4-build_src_configure() {
287 setqtenv 366 setqtenv
288 myconf="$(standard_configure_options) ${myconf}" 367
368 local conf="
369 -prefix ${QTPREFIXDIR}
370 -bindir ${QTBINDIR}
371 -libdir ${QTLIBDIR}
372 -docdir ${QTDOCDIR}
373 -headerdir ${QTHEADERDIR}
374 -plugindir ${QTPLUGINDIR}
375 -importdir ${QTIMPORTDIR}
376 -datadir ${QTDATADIR}
377 -translationdir ${QTTRANSDIR}
378 -sysconfdir ${QTSYSCONFDIR}
379 -examplesdir ${QTEXAMPLESDIR}
380 -demosdir ${QTDEMOSDIR}
381 -opensource -confirm-license
382 -shared -fast -largefile -stl -verbose
383 -nomake examples -nomake demos"
384
385 # ARCH is set on Gentoo. Qt now falls back to generic on an unsupported
386 # $(tc-arch). Therefore we convert it to supported values.
387 case "$(tc-arch)" in
388 amd64|x64-*) conf+=" -arch x86_64" ;;
389 ppc-macos) conf+=" -arch ppc" ;;
390 ppc|ppc64|ppc-*) conf+=" -arch powerpc" ;;
391 sparc|sparc-*|sparc64-*) conf+=" -arch sparc" ;;
392 x86-macos) conf+=" -arch x86" ;;
393 x86|x86-*) conf+=" -arch i386" ;;
394 alpha|arm|ia64|mips|s390) conf+=" -arch $(tc-arch)" ;;
395 hppa|sh) conf+=" -arch generic" ;;
396 *) die "$(tc-arch) is unsupported by this eclass. Please file a bug." ;;
397 esac
398
399 conf+=" -platform $(qt_mkspecs_dir)"
400
401 [[ $(get_libdir) != lib ]] && conf+=" -L${EPREFIX}/usr/$(get_libdir)"
402
403 # debug/release
404 if use debug; then
405 conf+=" -debug"
406 else
407 conf+=" -release"
408 fi
409 conf+=" -no-separate-debug-info"
410
411 # exceptions USE flag
412 conf+=" $(in_iuse exceptions && qt_use exceptions || echo -exceptions)"
413
414 # disable rpath on Qt >= 4.8 (bug 380415)
415 # but leave it enabled on prefix (bug 417169)
416 version_is_at_least 4.8 && use !prefix && conf+=" -no-rpath"
417
418 # precompiled headers don't work on hardened, where the flag is masked
419 conf+=" $(qt_use pch)"
420
421 # -reduce-relocations
422 # This flag seems to introduce major breakage to applications,
423 # mostly to be seen as a core dump with the message "QPixmap: Must
424 # construct a QApplication before a QPaintDevice" on Solaris.
425 # -- Daniel Vergien
426 [[ ${CHOST} != *-solaris* ]] && conf+=" -reduce-relocations"
289 427
290 # this one is needed for all systems with a separate -liconv, apart from 428 # this one is needed for all systems with a separate -liconv, apart from
291 # Darwin, for which the sources already cater for -liconv 429 # Darwin, for which the sources already cater for -liconv
292 use !elibc_glibc && [[ ${CHOST} != *-darwin* ]] && \ 430 if use !elibc_glibc && [[ ${CHOST} != *-darwin* ]]; then
293 myconf+=" -liconv" 431 conf+=" -liconv"
432 fi
294 433
295 if has glib ${IUSE//+} && use glib; then 434 if use_if_iuse glib; then
296 # use -I, -L and -l from configure
297 local glibflags="$(pkg-config --cflags --libs glib-2.0 gthread-2.0)" 435 local glibflags="$(pkg-config --cflags --libs glib-2.0 gthread-2.0)"
298 # avoid the -pthread argument 436 # avoid the -pthread argument
299 myconf+=" ${glibflags//-pthread}" 437 conf+=" ${glibflags//-pthread}"
300 unset glibflags 438 unset glibflags
301 fi 439 fi
302 440
441 if use_if_iuse qpa; then
442 echo
443 ewarn "The qpa useflag enables the Qt Platform Abstraction, formely"
444 ewarn "known as Qt Lighthouse. If you are not sure what that is, then"
445 ewarn "disable it before reporting any bugs related to this useflag."
446 echo
447 conf+=" -qpa"
448 fi
449
303 if use aqua ; then 450 if use aqua; then
304 # On (snow) leopard use the new (frameworked) cocoa code. 451 # On (snow) leopard use the new (frameworked) cocoa code.
305 if [[ ${CHOST##*-darwin} -ge 9 ]] ; then 452 if [[ ${CHOST##*-darwin} -ge 9 ]]; then
306 myconf+=" -cocoa -framework" 453 conf+=" -cocoa -framework"
454 # We need the source's headers, not the installed ones.
455 conf+=" -I${S}/include"
456 # Add hint for the framework location.
457 conf+=" -F${QTLIBDIR}"
307 458
308 # We are crazy and build cocoa + qt3support :-) 459 # We are crazy and build cocoa + qt3support :-)
309 if use qt3support; then 460 if use qt3support; then
310 sed -e "/case \"\$PLATFORM,\$CFG_MAC_COCOA\" in/,/;;/ s|CFG_QT3SUPPORT=\"no\"|CFG_QT3SUPPORT=\"yes\"|" \ 461 sed -e "/case \"\$PLATFORM,\$CFG_MAC_COCOA\" in/,/;;/ s|CFG_QT3SUPPORT=\"no\"|CFG_QT3SUPPORT=\"yes\"|" \
311 -i configure 462 -i configure || die
312 fi 463 fi
313 464 else
314 # We need the source's headers, not the installed ones. 465 conf+=" -no-framework"
315 myconf+=" -I${S}/include"
316
317 # Add hint for the framework location.
318 myconf+=" -F${QTLIBDIR}"
319 fi 466 fi
320 else 467 else
321 # freetype2 include dir is non-standard, thus include it on configure 468 # freetype2 include dir is non-standard, thus pass it to configure
322 # use -I from configure
323 myconf+=" $(pkg-config --cflags freetype2)" 469 conf+=" $(pkg-config --cflags-only-I freetype2)"
324 fi 470 fi
325 471
472 conf+=" ${myconf}"
473 myconf=
474
326 echo ./configure ${myconf} 475 echo ./configure ${conf}
327 ./configure ${myconf} || die "./configure failed" 476 ./configure ${conf} || die "./configure failed"
328 myconf="" 477
478 prepare_directories ${QT4_TARGET_DIRECTORIES}
329} 479}
330 480
331# @FUNCTION: qt4-build_src_compile 481# @FUNCTION: qt4-build_src_compile
482# @DESCRIPTION:
332# @DESCRIPTION: Actual compile phase 483# Actual compile phase
333qt4-build_src_compile() { 484qt4-build_src_compile() {
334 setqtenv 485 setqtenv
335 486
336 build_directories ${QT4_TARGET_DIRECTORIES} 487 build_directories ${QT4_TARGET_DIRECTORIES}
337} 488}
338 489
490# @FUNCTION: qt4-build_src_test
491# @DESCRIPTION:
492# Runs tests only in target directories.
493qt4-build_src_test() {
494 # QtMultimedia does not have any test suite (bug #332299)
495 [[ ${PN} == qt-multimedia ]] && return
496
497 for dir in ${QT4_TARGET_DIRECTORIES}; do
498 emake -j1 check -C ${dir}
499 done
500}
501
339# @FUNCTION: fix_includes 502# @FUNCTION: fix_includes
340# @DESCRIPTION: 503# @DESCRIPTION:
341# For MacOSX we need to add some symlinks when frameworks are 504# For MacOS X we need to add some symlinks when frameworks are
342# being used, to avoid complications with some more or less stupid packages. 505# being used, to avoid complications with some more or less stupid packages.
343fix_includes() { 506fix_includes() {
344 if use aqua && [[ ${CHOST##*-darwin} -ge 9 ]] ; then 507 if use aqua && [[ ${CHOST##*-darwin} -ge 9 ]]; then
508 local frw dest f h rdir
345 # Some packages tend to include <Qt/...> 509 # Some packages tend to include <Qt/...>
346 dodir "${QTHEADERDIR#${EPREFIX}}"/Qt 510 dodir "${QTHEADERDIR#${EPREFIX}}"/Qt
347 511
348 # Fake normal headers when frameworks are installed... eases life later on 512 # Fake normal headers when frameworks are installed... eases life later
349 local dest f 513 # on, make sure we use relative links though, as some ebuilds assume
514 # these dirs exist in src_install to add additional files
515 f=${QTHEADERDIR}
516 h=${QTLIBDIR}
517 while [[ -n ${f} && ${f%%/*} == ${h%%/*} ]] ; do
518 f=${f#*/}
519 h=${h#*/}
520 done
521 rdir=${h}
522 f="../"
523 while [[ ${h} == */* ]] ; do
524 f="${f}../"
525 h=${h#*/}
526 done
527 rdir="${f}${rdir}"
528
350 for frw in "${D}${QTLIBDIR}"/*.framework; do 529 for frw in "${D}${QTLIBDIR}"/*.framework; do
351 [[ -e "${frw}"/Headers ]] || continue 530 [[ -e "${frw}"/Headers ]] || continue
352 f=$(basename ${frw}) 531 f=$(basename ${frw})
353 dest="${QTHEADERDIR#${EPREFIX}}"/${f%.framework} 532 dest="${QTHEADERDIR#${EPREFIX}}"/${f%.framework}
354 dosym "${QTLIBDIR#${EPREFIX}}"/${f}/Headers "${dest}" 533 dosym "${rdir}"/${f}/Headers "${dest}"
355 534
356 # Link normal headers as well. 535 # Link normal headers as well.
357 for hdr in "${D}/${QTLIBDIR}/${f}"/Headers/*; do 536 for hdr in "${D}/${QTLIBDIR}/${f}"/Headers/*; do
358 h=$(basename ${hdr}) 537 h=$(basename ${hdr})
359 dosym "${QTLIBDIR#${EPREFIX}}"/${f}/Headers/${h} "${QTHEADERDIR#${EPREFIX}}"/Qt/${h} 538 dosym "../${rdir}"/${f}/Headers/${h} \
539 "${QTHEADERDIR#${EPREFIX}}"/Qt/${h}
360 done 540 done
361 done 541 done
362 fi 542 fi
363} 543}
364 544
365# @FUNCTION: qt4-build_src_install 545# @FUNCTION: qt4-build_src_install
366# @DESCRIPTION: 546# @DESCRIPTION:
367# Perform the actual installation including some library fixes. 547# Perform the actual installation including some library fixes.
368qt4-build_src_install() { 548qt4-build_src_install() {
369 [[ ${EAPI} == 2 ]] && use !prefix && ED=${D}
370 setqtenv 549 setqtenv
550
371 install_directories ${QT4_TARGET_DIRECTORIES} 551 install_directories ${QT4_TARGET_DIRECTORIES}
372 install_qconfigs 552 install_qconfigs
373 fix_library_files 553 fix_library_files
374 fix_includes 554 fix_includes
555
556 # remove .la files since we are building only shared libraries
557 prune_libtool_files
375} 558}
376 559
377# @FUNCTION: setqtenv 560# @FUNCTION: setqtenv
561# @INTERNAL
378setqtenv() { 562setqtenv() {
379 # Set up installation directories 563 # Set up installation directories
380 QTBASEDIR=${EPREFIX}/usr/$(get_libdir)/qt4
381 QTPREFIXDIR=${EPREFIX}/usr 564 QTPREFIXDIR=${EPREFIX}/usr
382 QTBINDIR=${EPREFIX}/usr/bin 565 QTBINDIR=${QTPREFIXDIR}/bin
383 QTLIBDIR=${EPREFIX}/usr/$(get_libdir)/qt4 566 QTLIBDIR=${QTPREFIXDIR}/$(get_libdir)/qt4
384 QMAKE_LIBDIR_QT=${QTLIBDIR}
385 QTPCDIR=${EPREFIX}/usr/$(get_libdir)/pkgconfig 567 QTPCDIR=${QTPREFIXDIR}/$(get_libdir)/pkgconfig
386 QTDATADIR=${EPREFIX}/usr/share/qt4
387 QTDOCDIR=${EPREFIX}/usr/share/doc/qt-${PV} 568 QTDOCDIR=${QTPREFIXDIR}/share/doc/qt-${PV}
388 QTHEADERDIR=${EPREFIX}/usr/include/qt4 569 QTHEADERDIR=${QTPREFIXDIR}/include/qt4
389 QTPLUGINDIR=${QTLIBDIR}/plugins 570 QTPLUGINDIR=${QTLIBDIR}/plugins
571 QTIMPORTDIR=${QTLIBDIR}/imports
572 QTDATADIR=${QTPREFIXDIR}/share/qt4
573 QTTRANSDIR=${QTDATADIR}/translations
390 QTSYSCONFDIR=${EPREFIX}/etc/qt4 574 QTSYSCONFDIR=${EPREFIX}/etc/qt4
391 QTTRANSDIR=${QTDATADIR}/translations
392 QTEXAMPLESDIR=${QTDATADIR}/examples 575 QTEXAMPLESDIR=${QTDATADIR}/examples
393 QTDEMOSDIR=${QTDATADIR}/demos 576 QTDEMOSDIR=${QTDATADIR}/demos
394 QT_INSTALL_PREFIX=${EPREFIX}/usr/$(get_libdir)/qt4 577 QMAKE_LIBDIR_QT=${QTLIBDIR}
578
395 PLATFORM=$(qt_mkspecs_dir) 579 PLATFORM=$(qt_mkspecs_dir)
396
397 unset QMAKESPEC 580 unset QMAKESPEC
398}
399 581
400# @FUNCTION: standard_configure_options 582 export XDG_CONFIG_HOME="${T}"
401# @DESCRIPTION: 583}
402# Sets up some standard configure options, like libdir (if necessary), whether
403# debug info is wanted or not.
404standard_configure_options() {
405 local myconf=
406 584
407 [[ $(get_libdir) != lib ]] && myconf+=" -L${EPREFIX}/usr/$(get_libdir)" 585# @FUNCTION: prepare_directories
586# @USAGE: < directories >
587# @INTERNAL
588# @DESCRIPTION:
589# Generates Makefiles for the given list of directories.
590prepare_directories() {
591 # avoid running over the maximum argument number, bug #299810
592 {
593 echo "${S}"/mkspecs/common/*.conf
594 find "${S}" -name '*.pr[io]'
595 } | xargs sed -i \
596 -e "s:\$\$\[QT_INSTALL_LIBS\]:${QTLIBDIR}:g" \
597 -e "s:\$\$\[QT_INSTALL_PLUGINS\]:${QTPLUGINDIR}:g" \
598 || die
408 599
409 # Disable visibility explicitly if gcc version isn't 4 600 for x in "$@"; do
410 if [[ $(gcc-major-version) -lt 4 ]]; then 601 pushd "${S}"/${x} >/dev/null || die
411 myconf+=" -no-reduce-exports" 602 einfo "Running qmake in: ${x}"
412 fi 603 "${S}"/bin/qmake \
413 604 "LIBS+=-L${QTLIBDIR}" \
414 # precompiled headers doesn't work on hardened, where the flag is masked. 605 "CONFIG+=nostrip" \
415 myconf+=" $(qt_use pch)" 606 || die "qmake failed"
416 607 popd >/dev/null || die
417 if use debug; then 608 done
418 myconf+=" -debug"
419 else
420 myconf+=" -release"
421 fi
422 myconf+=" -no-separate-debug-info"
423
424 use aqua && myconf+=" -no-framework"
425
426 # ARCH is set on Gentoo. Qt now falls back to generic on an unsupported
427 # $(tc-arch). Therefore we convert it to supported values.
428 case "$(tc-arch)" in
429 amd64|x64-*) myconf+=" -arch x86_64" ;;
430 ppc-macos) myconf+=" -arch ppc" ;;
431 ppc|ppc64|ppc-*) myconf+=" -arch powerpc" ;;
432 sparc|sparc-*) myconf+=" -arch sparc" ;;
433 x86-macos) myconf+=" -arch x86" ;;
434 x86|x86-*) myconf+=" -arch i386" ;;
435 alpha|arm|ia64|mips|s390|sparc) myconf+=" -arch $(tc-arch)" ;;
436 hppa|sh) myconf+=" -arch generic" ;;
437 *) die "$(tc-arch) is unsupported by this eclass. Please file a bug." ;;
438 esac
439
440 # 4.5: build everything but qt-xmlpatterns w/o exceptions
441 # 4.6: exceptions USE flag
442 local exceptions="-exceptions"
443 case "${PV}" in
444 4.5.*)
445 [[ ${PN} == "qt-xmlpatterns" ]] || exceptions="-no-exceptions"
446 ;;
447 *)
448 has exceptions "${IUSE//+}" && exceptions="$(qt_use exceptions)"
449 ;;
450 esac
451
452 # note about -reduce-relocations:
453 # That flag seems to introduce major breakage to applications,
454 # mostly to be seen as a core dump with the message "QPixmap: Must
455 # construct a QApplication before a QPaintDevice" on Solaris
456 # -- Daniel Vergien
457 [[ ${CHOST} != *-solaris* ]] && myconf+=" -reduce-relocations"
458
459 myconf+=" -platform $(qt_mkspecs_dir) -stl -verbose -largefile -confirm-license
460 -prefix ${QTPREFIXDIR} -bindir ${QTBINDIR} -libdir ${QTLIBDIR}
461 -datadir ${QTDATADIR} -docdir ${QTDOCDIR} -headerdir ${QTHEADERDIR}
462 -plugindir ${QTPLUGINDIR} -sysconfdir ${QTSYSCONFDIR}
463 -translationdir ${QTTRANSDIR} -examplesdir ${QTEXAMPLESDIR}
464 -demosdir ${QTDEMOSDIR} -silent -fast -opensource
465 ${exceptions}
466 -nomake examples -nomake demos"
467
468 echo "${myconf}"
469} 609}
470 610
471# @FUNCTION: build_directories 611# @FUNCTION: build_directories
472# @USAGE: < directories > 612# @USAGE: < directories >
613# @INTERNAL
473# @DESCRIPTION: 614# @DESCRIPTION:
474# Compiles the code in $QT4_TARGET_DIRECTORIES 615# Compiles the code in the given list of directories.
475build_directories() { 616build_directories() {
476 for x in "$@"; do 617 for x in "$@"; do
477 pushd "${S}"/${x} >/dev/null 618 pushd "${S}"/${x} >/dev/null || die
478 # avoid running over the maximum argument number, bug #299810 619 emake \
479 { 620 AR="$(tc-getAR) cqs" \
480 echo "${S}"/mkspecs/common/*.conf
481 find "${S}" -name '*.pr[io]'
482 } | xargs sed -i -e "s:\$\$\[QT_INSTALL_LIBS\]:${EPREFIX}/usr/$(get_libdir)/qt4:g" || die
483 "${S}"/bin/qmake "LIBS+=-L${QTLIBDIR}" "CONFIG+=nostrip" || die "qmake failed"
484 emake CC="$(tc-getCC)" \ 621 CC="$(tc-getCC)" \
485 CXX="$(tc-getCXX)" \ 622 CXX="$(tc-getCXX)" \
486 LINK="$(tc-getCXX)" || die "emake failed" 623 LINK="$(tc-getCXX)" \
624 RANLIB=":" \
625 STRIP=":" \
626 || die "emake failed"
487 popd >/dev/null 627 popd >/dev/null || die
488 done 628 done
489} 629}
490 630
491# @FUNCTION: install_directories 631# @FUNCTION: install_directories
492# @USAGE: < directories > 632# @USAGE: < directories >
633# @INTERNAL
493# @DESCRIPTION: 634# @DESCRIPTION:
494# run emake install in the given directories, which are separated by spaces 635# Runs emake install in the given directories, which are separated by spaces.
495install_directories() { 636install_directories() {
496 for x in "$@"; do 637 for x in "$@"; do
497 pushd "${S}"/${x} >/dev/null || die "Can't pushd ${S}/${x}" 638 pushd "${S}"/${x} >/dev/null || die
498 emake INSTALL_ROOT="${D}" install || die "emake install failed" 639 emake INSTALL_ROOT="${D}" install || die "emake install failed"
499 popd >/dev/null || die "Can't popd from ${S}/${x}" 640 popd >/dev/null || die
500 done 641 done
501} 642}
502 643
503# @ECLASS-VARIABLE: QCONFIG_ADD 644# @ECLASS-VARIABLE: QCONFIG_ADD
504# @DESCRIPTION: 645# @DESCRIPTION:
514# @DESCRIPTION: 655# @DESCRIPTION:
515# List variables that should be defined at the top of QtCore/qconfig.h 656# List variables that should be defined at the top of QtCore/qconfig.h
516: ${QCONFIG_DEFINE:=} 657: ${QCONFIG_DEFINE:=}
517 658
518# @FUNCTION: install_qconfigs 659# @FUNCTION: install_qconfigs
660# @INTERNAL
661# @DESCRIPTION:
519# @DESCRIPTION: Install gentoo-specific mkspecs configurations 662# Install gentoo-specific mkspecs configurations.
520install_qconfigs() { 663install_qconfigs() {
521 local x 664 local x
522 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} ]]; then 665 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} ]]; then
523 for x in QCONFIG_ADD QCONFIG_REMOVE; do 666 for x in QCONFIG_ADD QCONFIG_REMOVE; do
524 [[ -n ${!x} ]] && echo ${x}=${!x} >> "${T}"/${PN}-qconfig.pri 667 [[ -n ${!x} ]] && echo ${x}=${!x} >> "${T}"/${PN}-qconfig.pri
535 doins "${T}"/gentoo-${PN}-qconfig.h || die "installing ${PN}-qconfig.h failed" 678 doins "${T}"/gentoo-${PN}-qconfig.h || die "installing ${PN}-qconfig.h failed"
536 fi 679 fi
537} 680}
538 681
539# @FUNCTION: generate_qconfigs 682# @FUNCTION: generate_qconfigs
540# @DESCRIPTION: Generates gentoo-specific configurations 683# @INTERNAL
684# @DESCRIPTION:
685# Generates gentoo-specific qconfig.{h,pri}.
541generate_qconfigs() { 686generate_qconfigs() {
542 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} || -n ${QCONFIG_DEFINE} || ${CATEGORY}/${PN} == x11-libs/qt-core ]]; then 687 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} || -n ${QCONFIG_DEFINE} || ${PN} == qt-core ]]; then
543 local x qconfig_add qconfig_remove qconfig_new 688 local x qconfig_add qconfig_remove qconfig_new
544 for x in "${ROOT}${QTDATADIR}"/mkspecs/gentoo/*-qconfig.pri; do 689 for x in "${ROOT}${QTDATADIR}"/mkspecs/gentoo/*-qconfig.pri; do
545 [[ -f ${x} ]] || continue 690 [[ -f ${x} ]] || continue
546 qconfig_add+=" $(sed -n 's/^QCONFIG_ADD=//p' "${x}")" 691 qconfig_add+=" $(sed -n 's/^QCONFIG_ADD=//p' "${x}")"
547 qconfig_remove+=" $(sed -n 's/^QCONFIG_REMOVE=//p' "${x}")" 692 qconfig_remove+=" $(sed -n 's/^QCONFIG_REMOVE=//p' "${x}")"
559 704
560 # generate list of QT_CONFIG entries from the existing list 705 # generate list of QT_CONFIG entries from the existing list
561 # including qconfig_add and excluding qconfig_remove 706 # including qconfig_add and excluding qconfig_remove
562 for x in $(sed -n 's/^QT_CONFIG +=//p' \ 707 for x in $(sed -n 's/^QT_CONFIG +=//p' \
563 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri) ${qconfig_add}; do 708 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri) ${qconfig_add}; do
564 hasq ${x} ${qconfig_remove} || qconfig_new+=" ${x}" 709 has ${x} ${qconfig_remove} || qconfig_new+=" ${x}"
565 done 710 done
566 711
567 # replace the existing QT_CONFIG list with qconfig_new 712 # replace the existing QT_CONFIG list with qconfig_new
568 if ! sed -i -e "s/QT_CONFIG +=.*/QT_CONFIG += ${qconfig_new}/" \ 713 if ! sed -i -e "s/QT_CONFIG +=.*/QT_CONFIG += ${qconfig_new}/" \
569 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri; then 714 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri; then
593 fi 738 fi
594 fi 739 fi
595} 740}
596 741
597# @FUNCTION: qt4-build_pkg_postrm 742# @FUNCTION: qt4-build_pkg_postrm
743# @DESCRIPTION:
598# @DESCRIPTION: Generate configurations when the package is completely removed 744# Regenerate configuration when the package is completely removed.
599qt4-build_pkg_postrm() { 745qt4-build_pkg_postrm() {
600 generate_qconfigs 746 generate_qconfigs
601} 747}
602 748
603# @FUNCTION: qt4-build_pkg_postinst 749# @FUNCTION: qt4-build_pkg_postinst
750# @DESCRIPTION:
604# @DESCRIPTION: Generate configuration, plus throws a message about possible 751# Regenerate configuration, plus throw a message about possible
605# breakages and proposed solutions. 752# breakages and proposed solutions.
606qt4-build_pkg_postinst() { 753qt4-build_pkg_postinst() {
607 generate_qconfigs 754 generate_qconfigs
608} 755}
609 756
610# @FUNCTION: skip_qmake_build_patch 757# @FUNCTION: skip_qmake_build
758# @INTERNAL
611# @DESCRIPTION: 759# @DESCRIPTION:
612# Don't need to build qmake, as it's already installed from qt-core 760# Patches configure to skip qmake compilation, as it's already installed by qt-core.
613skip_qmake_build_patch() { 761skip_qmake_build() {
614 # Don't need to build qmake, as it's already installed from qt-core
615 sed -i -e "s:if true:if false:g" "${S}"/configure || die "Sed failed" 762 sed -i -e "s:if true:if false:g" "${S}"/configure || die
616} 763}
617 764
618# @FUNCTION: skip_project_generation_patch 765# @FUNCTION: skip_project_generation
766# @INTERNAL
619# @DESCRIPTION: 767# @DESCRIPTION:
620# Exit the script early by throwing in an exit before all of the .pro files are scanned 768# Exit the script early by throwing in an exit before all of the .pro files are scanned.
621skip_project_generation_patch() { 769skip_project_generation() {
622 # Exit the script early by throwing in an exit before all of the .pro files are scanned
623 sed -e "s:echo \"Finding:exit 0\n\necho \"Finding:g" \ 770 sed -i -e "s:echo \"Finding:exit 0\n\necho \"Finding:g" "${S}"/configure || die
624 -i "${S}"/configure || die "Sed failed"
625} 771}
626 772
627# @FUNCTION: symlink_binaries_to_buildtree 773# @FUNCTION: symlink_binaries_to_buildtree
774# @INTERNAL
628# @DESCRIPTION: 775# @DESCRIPTION:
629# Symlink generated binaries to buildtree so they can be used during compilation 776# Symlinks generated binaries to buildtree, so they can be used during compilation time.
630# time
631symlink_binaries_to_buildtree() { 777symlink_binaries_to_buildtree() {
632 for bin in qmake moc uic rcc; do 778 for bin in qmake moc uic rcc; do
633 ln -s ${QTBINDIR}/${bin} "${S}"/bin/ || die "Symlinking ${bin} to ${S}/bin failed." 779 ln -s "${QTBINDIR}"/${bin} "${S}"/bin/ || die "symlinking ${bin} to ${S}/bin failed"
634 done 780 done
635} 781}
636 782
637# @FUNCTION: fix_library_files 783# @FUNCTION: fix_library_files
784# @INTERNAL
638# @DESCRIPTION: 785# @DESCRIPTION:
639# Fixes the pathes in *.la, *.prl, *.pc, as they are wrong due to sandbox and 786# Fixes the paths in *.la, *.prl, *.pc, as they are wrong due to sandbox and
640# moves the *.pc-files into the pkgconfig directory 787# moves the *.pc files into the pkgconfig directory.
641fix_library_files() { 788fix_library_files() {
789 local libfile
642 for libfile in "${D}"/${QTLIBDIR}/{*.la,*.prl,pkgconfig/*.pc}; do 790 for libfile in "${D}"/${QTLIBDIR}/{*.la,*.prl,pkgconfig/*.pc}; do
643 if [[ -e ${libfile} ]]; then 791 if [[ -e ${libfile} ]]; then
644 sed -i -e "s:${S}/lib:${QTLIBDIR}:g" ${libfile} || die "Sed on ${libfile} failed." 792 sed -i -e "s:${S}/lib:${QTLIBDIR}:g" ${libfile} || die "sed on ${libfile} failed"
645 fi 793 fi
646 done 794 done
647 795
648 # pkgconfig files refer to WORKDIR/bin as the moc and uic locations. Fix: 796 # pkgconfig files refer to WORKDIR/bin as the moc and uic locations
649 for libfile in "${D}"/${QTLIBDIR}/pkgconfig/*.pc; do 797 for libfile in "${D}"/${QTLIBDIR}/pkgconfig/*.pc; do
650 if [[ -e ${libfile} ]]; then 798 if [[ -e ${libfile} ]]; then
651 sed -i -e "s:${S}/bin:${QTBINDIR}:g" ${libfile} || die "Sed failed" 799 sed -i -e "s:${S}/bin:${QTBINDIR}:g" ${libfile} || die "sed on ${libfile} failed"
652 800
653 # Move .pc files into the pkgconfig directory 801 # Move .pc files into the pkgconfig directory
654 dodir ${QTPCDIR#${EPREFIX}} 802 dodir ${QTPCDIR#${EPREFIX}}
655 mv ${libfile} "${D}"/${QTPCDIR}/ \ 803 mv ${libfile} "${D}"/${QTPCDIR}/ || die "moving ${libfile} to ${D}/${QTPCDIR}/ failed"
656 || die "Moving ${libfile} to ${D}/${QTPCDIR}/ failed."
657 fi 804 fi
658 done 805 done
659 806
660 # Don't install an empty directory 807 # Don't install an empty directory
661 rmdir "${D}"/${QTLIBDIR}/pkgconfig 808 rmdir "${D}"/${QTLIBDIR}/pkgconfig
662} 809}
663 810
664# @FUNCTION: qt_use 811# @FUNCTION: qt_use
665# @USAGE: < flag > [ feature ] [ enableval ] 812# @USAGE: < flag > [ feature ] [ enableval ]
666# @DESCRIPTION: 813# @DESCRIPTION:
667# This will echo "${enableval}-${feature}" if <flag> is enabled, or 814# This will echo "-${enableval}-${feature}" if <flag> is enabled, or
668# "-no-${feature} if the flag is disabled. If [feature] is not specified <flag> 815# "-no-${feature}" if it's disabled. If [feature] is not specified, <flag>
669# will be used for that. If [enableval] is not specified, it omits the 816# will be used for that. If [enableval] is not specified, it omits the
670# assignment-part 817# "-${enableval}" part.
671qt_use() { 818qt_use() {
672 local flag=$1 819 use "$1" && echo "${3:+-$3}-${2:-$1}" || echo "-no-${2:-$1}"
673 local feature=$1
674 local enableval=
675
676 [[ -n $2 ]] && feature=$2
677 [[ -n $3 ]] && enableval=-$3
678
679 if use ${flag}; then
680 echo "${enableval}-${feature}"
681 else
682 echo "-no-${feature}"
683 fi
684} 820}
685 821
686# @FUNCTION: qt_mkspecs_dir 822# @FUNCTION: qt_mkspecs_dir
687# @RETURN: the specs-directory w/o path 823# @RETURN: the specs-directory w/o path
688# @DESCRIPTION: 824# @DESCRIPTION:
689# Allows us to define which mkspecs dir we want to use. 825# Allows us to define which mkspecs dir we want to use.
690qt_mkspecs_dir() { 826qt_mkspecs_dir() {
691 # Allows us to define which mkspecs dir we want to use.
692 local spec 827 local spec=
693 828
694 case ${CHOST} in 829 case "${CHOST}" in
695 *-freebsd*|*-dragonfly*) 830 *-freebsd*|*-dragonfly*)
696 spec=freebsd ;; 831 spec=freebsd ;;
697 *-openbsd*) 832 *-openbsd*)
698 spec=openbsd ;; 833 spec=openbsd ;;
699 *-netbsd*) 834 *-netbsd*)
710 *-solaris*) 845 *-solaris*)
711 spec=solaris ;; 846 spec=solaris ;;
712 *-linux-*|*-linux) 847 *-linux-*|*-linux)
713 spec=linux ;; 848 spec=linux ;;
714 *) 849 *)
715 die "Unknown CHOST, no platform choosen." 850 die "${FUNCNAME}(): Unknown CHOST '${CHOST}'" ;;
716 esac 851 esac
717 852
718 CXX=$(tc-getCXX) 853 case "$(tc-getCXX)" in
719 if [[ ${CXX} == *g++* ]]; then 854 *g++*)
720 spec+=-g++ 855 spec+=-g++ ;;
721 elif [[ ${CXX} == *icpc* ]]; then 856 *icpc*)
722 spec+=-icc 857 spec+=-icc ;;
723 else 858 *)
724 die "Unknown compiler ${CXX}." 859 die "${FUNCNAME}(): Unknown compiler '$(tc-getCXX)'" ;;
725 fi 860 esac
726 if [[ -n ${LIBDIR/lib} ]]; then
727 spec+=-${LIBDIR/lib}
728 fi
729 861
730 # Add -64 for 64bit profiles 862 # Add -64 for 64bit profiles
731 if use x64-freebsd || 863 if use x64-freebsd ||
732 use amd64-linux || 864 use amd64-linux ||
733 use x64-macos || 865 use x64-macos ||
738 fi 870 fi
739 871
740 echo "${spec}" 872 echo "${spec}"
741} 873}
742 874
875# @FUNCTION: qt_nolibx11
876# @INTERNAL
877# @DESCRIPTION:
878# Ignore X11 tests for packages that don't need X libraries installed.
879qt_nolibx11() {
880 sed -i "/unixtests\/compile.test.*config.tests\/x11\/xlib/,/fi$/d" "${S}"/configure ||
881 die "x11 check sed failed"
882}
883
743EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_install pkg_postrm pkg_postinst 884EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_install src_test pkg_postrm pkg_postinst

Legend:
Removed from v.1.74  
changed lines
  Added in v.1.139

  ViewVC Help
Powered by ViewVC 1.1.20